/** PM Lab 4 - ADC */

void timer_setup(){
  // set timer A for 10ms
  TCCR0A = 0;
  TCCR0B = 0;
  TCNT0  = 0;

  OCR0A = 156;            // compare match -> 10ms
  TCCR0A |= (1 << WGM01);   // CTC mode
  TCCR0B |= ((1 << CS02) | (1 << CS00));    // 1024 prescaler 
  TIMSK0 |= (1 << OCIE0A);

  // Enable timer as source
  ADCSRB |= ((1 << ADTS0) | (1 << ADTS1));
}

void button_setup(){
  // Select INT0 as trigger source
  ADCSRB = 0;
  ADCSRB |= (1 << ADTS1);

  // Enable INT0
  EICRA |= (1 << ISC00);
  EIMSK |= (1 << INT0);
}


void setup()
{
    
  // disable interrupts
  cli();
  
  ADMUX = 0;
  /* AVCC with external capacitor at AREF pin */
  ADMUX |= (1 << REFS0);

  ADCSRA = 0;
  /* set prescaler at 128 */
  ADCSRA |= (7 << ADPS0);

  // Enable auto-trigger
  ADCSRA |= (1 << ADATE);
  // Enable Intrerupt
  ADCSRA |= (1 << ADIE);

  // Set button as trigger source
  button_setup();

  // Select Timer as trigger source
  //timer_setup();
  
  /* enable ADC */
  ADCSRA |= (1 << ADEN);
 
  // Enable interrupts
  sei();
  Serial.begin(9600);
}

ISR(ADC_vect){
  Serial.println(ADC);
}

ISR(INT0_vect)
{
  Serial.println("Button Pressed!");
}

ISR(TIMER0_COMPA_vect){
  // Even if this does nothing. It has to be here to reset the timer interrupt flag
}

void loop()
{
  delay(50);
}
